



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Golang 入门~~基础知识</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Golang 入门~~基础知识</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-26 01:26:15 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>变量声明</h2>
<div>
<pre class="prettyprint linenums">//通用形式，指定变量名，变量类型，变量值<br />
var name int = 99<br />
fmt.Println(name)

//指定变量名，以及变量类型，未指定值的时候默认是类型零值<br />
var age int<br />
//可以后面赋值<br />
age = 88<br />
fmt.Println(age)

//短变量声明，指定变量名，以及变量的值，而变量类型会自动由值的类型决定。<br />
gender := "male" //gender变量的类型是string<br />
fmt.Println(gender)

//变量列表  要求：左右两边变量名与值的数量相同<br />
//先定义，然后赋值<br />
var x, y, z int //x,y,z都是int类型<br />
x, y, z = 1, 2, 4<br />
fmt.Println(x, y, z)

//先定义，同时赋值<br />
var o, p, q = "abc", true, 3.14<br />
fmt.Println(o, p, q)

//使用短变量的变量列表形式，需要注意，左边至少有一个新变量声明，否则报错<br />
o, r, s, t := "changed", "xyz", false, 99<br />
fmt.Println(o, r, s, t)
</pre>
</div>
<p>　　注意，在函数中（包括自己定义的函数或者主函数中）声明的变量如果没有使用，在编译的时候，会报错。</p>
<p>　　在函数外面定义全局变量不能使用短变量形式。</p>
<h2>常量</h2>
<div>
<pre class="prettyprint linenums">const x = 13<br />
const p int = 13<br />
const pp, ppp = 1, 2<br />
const (<br />
	i  = 10<br />
	ii = 20<br />
)
</pre>
</div>
<p>　　在声明常量的时候，必须指定值，否则出错。</p>
<p>　　声明在函数中的常量不使用，并不会报错，只有声明的变量或者导入的包未使用才会报错。</p>
<p>　　注意下面这个用法：</p>
<div>
<pre class="prettyprint linenums">const (<br />
	i = 1<br />
	ii<br />
	iii = 2<br />
	iiii<br />
)<br />
fmt.Println(i, ii, iii, iiii)// 1 1 2 2
</pre>
</div>
<p>　　定义多个常量时，如果某个变量没有执行值，那么就会沿用上一个常量的值。</p>
<h2>const与iota</h2>
<p>　　在和const联用时，iota的作用是：iota初始值为0，每出现一个常量，iota就加1</p>
<div>
<pre class="prettyprint linenums">const (<br />
	i = iota<br />
	ii<br />
	iii  = 4<br />
	iiii = iota<br />
)<br />
fmt.Println(i, ii, iii, iiii) //0 1 4 3
</pre>
</div>
<p>　　</p>
<h2>数据类型</h2>
<p>　　基本数据类型：string、bool、intX、floatX</p>
<p>　　复合数据类型：array、struct</p>
<p>　　引用类型：point、slice、map、func、channel</p>
<p>　　接口类型：interface</p>
<h2>运算符</h2>
<p>　　和其他语言一样，注意--、 ++只能后置，即只能i++、i--。</p>
<p>　　逻辑运算符||、&amp;&amp;、！，这3个运算符左右两边的表达式必须是bool型，不能是int或者string类型。</p>
<h2>类型强制转换</h2>
<p>　　在两种类型的变量相互赋值或者进行比较时，Go语言不会像其他语言一样进行隐式转换，所以必须进行显式地转换。</p>
<p>　　所以下面两种做法是不可行的：</p>
<div>
<pre class="prettyprint linenums">var f1 float32 = 3.14<br />
var f2 float64 = 6.28<br />
//类型不同，不能进行比较，会报错<br />
//	fmt.Println(f1 == f2)

//类型不同，不能进行运算<br />
f3 := f1 - f2<br />
fmt.Println(f3)
</pre>
</div>
<p>　　解决方法：</p>
<div>
<pre class="prettyprint linenums">var f1 float32 = 3.14<br />
var f2 float64 = 6.28

//进行强制转换<br />
f := float32(f2)

fmt.Println(f1 == f) //false

f3 := f1 - f<br />
fmt.Println(f3) //0
</pre>
</div>
<p>　　</p>
<h2>复数</h2>
<div>
<pre class="prettyprint linenums">c := complex(3, 4)<br />
fmt.Println(real(c), imag(c))//3 4
</pre>
</div>
<p>　　</p>
<h2>布尔值</h2>
<p>　　注意bool值的true或者false，并不会自动转换为整型的1或者0。</p>
<h2>字符型</h2>
<p>　　单引号只能用来表示单个字符，不能用来括字符串。</p>
<p>　　双引号技能括单个字符，又能括字符串。</p>
<div>
<pre class="prettyprint linenums">a := 'ab'   //wrong<br />
b := 'x'    //correct<br />
c := "y"	//correct<br />
d := "abc"	//correct
</pre>
</div>
<p>　　</p>
<h2>字符串　　</h2>
<div>
<pre class="prettyprint linenums">str1 := "你 "<br />
str2 := "好"<br />
//使用 + 进行字符串拼接<br />
str3 := str1 + str2 //你 好<br />
fmt.Println(str3)

length := len(str1)<br />
//使用len()求字符串的长度时，求的是字节数，不是字符数<br />
fmt.Println(length) //4

str := "hello world"<br />
//取某一个索引的字符<br />
fmt.Println(str[0])         //104<br />
fmt.Println(string(str[0])) //h

//错误用法，不能修改字符串内部的值<br />
//str[0] = "d"

//可以改变字符串的值<br />
str = "go to hell"<br />
fmt.Println(str)  //go to hell
</pre>
</div>
<p>　　</p>
<h2>字符串截断</h2>
<p>　　截断格式str[start:end]，左闭右开区间，即end位置的字符不会包含在内。省略start时，默认start为0。省略end时，默认end为字符串长度len(str)。</p>
<div>
<pre class="prettyprint linenums">str := "abcdefg"<br />
fmt.Println(str[2:4]) //cd<br />
fmt.Println(str[2:])  //cdefg<br />
fmt.Println(str[:4])  //abcd
</pre>
</div>
<p>　　</p>
<h2>字符串遍历</h2>
<div>
<pre class="prettyprint linenums">str := "abcdefg"<br />
length := len(str)<br />
for i := 0; i &lt; length; i++ {<br />
	fmt.Println(str[i], string(str[i]))<br />
}<br />
for index, value := range str {<br />
	fmt.Println(index, string(value))<br />
}
</pre>
</div>
<p>　　</p>
<h2>原生字符串字面值</h2>
<p>　　使用``代替双引号。可以保存内容的格式，原样输出</p>
<div>
<pre class="prettyprint linenums">str := `<br />
menu:<br />
	1、<br />
	2、<br />
`<br />
	fmt.Println(str)</pre>
</div>
<p>　　</p>
<h2>指针</h2>
<div>
<pre class="prettyprint linenums">var num int = 10<br />
var p *int = &amp;num<br />
//	等价于<br />
//p := &amp;num<br />
fmt.Println(num, p, *p) //10 0xc42001a0f0 10
</pre>
</div>
<p>　　注意事项：</p>
<p>　　指针的默认值是nil，不是NULL，并且go语言中没有NULL常量</p>
<p>　　使用&amp;取地址，使用*解引用</p>
<p>　　不支持C语言类似的指针运算，比如指针自增等。</p>
<p>　　使用&ldquo;.&rdquo;来访问目标成员，不支持&ldquo;-&gt;&rdquo;运算符</p>
<p>　　不存在函数指针</p>
<h3>结构体指针</h3>
<div>
<pre class="prettyprint linenums">package main<br />
import "fmt"<br />
type person struct {<br />
	Name string<br />
	Age  int<br />
}<br />
func main() {<br />
	p := &amp;person{"abc", 90}<br />
	name := p.Name<br />
	//等价于<br />
	//name := (*p).Name<br />
	fmt.Println(name)<br />
}
</pre>
</div>
<h3>数组指针</h3>
<div>
<pre class="prettyprint linenums">arr := [3]int{99, 999, 9999}<br />
p := &amp;arr<br />
fmt.Println(arr) //[99 999 9999]<br />
fmt.Println(p)   //&amp;[99 999 9999]<br />
fmt.Println(*p)  //[99 999 9999]
</pre>
</div>
<h3>指针数组</h3>
<div>
<pre class="prettyprint linenums">var p [3]*int<br />
x, y, z := 1, 11, 111<br />
p[0], p[1], p[2] = &amp;x, &amp;y, &amp;z<br />
fmt.Println(p[0], p[1], p[2])    //0xc42001a0f0 0xc42001a0f8 0xc42001a100<br />
fmt.Println(*p[0], *p[1], *p[2]) //1   11  111
</pre>
</div>
<h3>二级指针</h3>
<div>
<pre class="prettyprint linenums">var num int = 10<br />
p := &amp;num             //p保存着num的地址<br />
pp := &amp;p              //pp保存着p的地址，即地址的地址<br />
fmt.Println(p, *pp)   //0xc42001a0f0 0xc42001a0f0<br />
fmt.Println(&amp;p, pp)   //0xc42000c028 0xc42000c028<br />
fmt.Println(*p, **pp) //10 10
</pre>
</div>
<p>　　</p>
<h2>type定义类型</h2>
<p>　　使用type关键字定义新的类型名，一般出现在包一级，即函数外部，如果新建的类型名字首字母大写，则在包外可以使用，否则只能在包内使用。</p>
<p>　　格式：type new_type base_type</p>
<p>　　注意type和C语言的typedef不同，typedef只是定义别名而已，而Go语言的type不仅定义类型名称，还包括类型的行为。</p>
<div>
<pre class="prettyprint linenums">package main<br />
import "fmt"<br />
type Score int<br />
func (s Score) Pass() bool {<br />
	return s &gt;= 60<br />
}<br />
func main() {<br />
	var s1 Score = 69<br />
	fmt.Println(s1.Pass()) //true<br />
}
</pre>
</div>
<p>　　虽然使用type关键字定义了一个新的类型，就像上面的Score和int，虽然在底层都是int，底层都是同一个类型，但是：不能直接进行比较、计算，必须要先转换后才可比较和计算。</p>
<h2>标准输入输出</h2>
<h3>　　Print、Println、Printf</h3>
<div>
<pre class="prettyprint linenums">a, b, c := 1, "abc", true<br />
fmt.Println(a, b, c)              //1 abc true<br />
fmt.Print(a, b, c, "\n")          //1abctrue<br />
fmt.Printf("%d,%s,%t\n", a, b, c) //1,abc,true
</pre>
</div>
<h3>　　Scan</h3>
<div>
<pre class="prettyprint linenums">var (<br />
	name string<br />
	age  int<br />
)<br />
for {<br />
	fmt.Println("please intput name,age")<br />
	fmt.Scan(&amp;name, &amp;age)<br />
	fmt.Println("name:", name, "\t age:", age, "\n")<br />
}</pre>
</div>
<p>　　运行结果如下：</p>
<div>
<pre class="prettyprint linenums">please intput name,age<br />
abc 30<br />
name: abc 	 age: 30 

please intput name,age<br />
abc<br />
50<br />
name: abc 	 age: 50 

please intput name,age<br />
abc 50 xyz 99<br />
name: abc 	 age: 50 

please intput name,age<br />
name: xyz 	 age: 99
</pre>
</div>
<p>　　</p>
<h3>　Scanln</h3>
<div>
<pre class="prettyprint linenums">var (<br />
	name  string<br />
	age   int<br />
	score int<br />
)<br />
for {<br />
	fmt.Println("please intput name,age,score")<br />
	fmt.Scanln(&amp;name, &amp;age, &amp;score)<br />
	fmt.Println("name:", name, "\t age:", age, "\t score:", score, "\n")<br />
}
</pre>
</div>
<p>　　运行结果如下：</p>
<div>
<pre class="prettyprint linenums">please intput name,age,score<br />
abc<br />
name: abc 	 age: 0 	 score: 0 

please intput name,age,score<br />
abc 30<br />
name: abc 	 age: 30 	 score: 0 

please intput name,age,score<br />
abc 30 99<br />
name: abc 	 age: 30 	 score: 99
</pre>
</div>
<p>　　</p>
<h3>　　Scanf</h3>
<div>
<pre class="prettyprint linenums">var (<br />
	name string<br />
	age  int<br />
)<br />
fmt.Println("please intput name,age")<br />
fmt.Scanf("%s %d", &amp;name, &amp;age) //输入时以空格分隔<br />
fmt.Println("name:", name, "\t age:", age, "\n")

fmt.Println("please intput name,age")<br />
fmt.Scanf("%s,%d", &amp;name, &amp;age) //输入时，以逗号分隔<br />
fmt.Println("name:", name, "\t age:", age, "\n")
</pre>
</div>
<p>　　运行结果</p>
<div>
<pre class="prettyprint linenums">please intput name,age<br />
abc 99<br />
name: abc 	 age: 99 

please intput name,age<br />
xyz 88<br />
name: xyz 	 age: 99
</pre>
</div>
<p>　　</p>
<p>　　注意，Scan并不会在遇到回车换行的时候结束输入。而Scanln和Scanf都是一旦遇到回车换行，就认为本轮输入（一个Scanln或者Scanf）结束，执行下一个Scanln或者Scanf。当然，缓冲的数据，可以自动赋值。</p>
<h2>if选择结构</h2>
<div>
<pre class="prettyprint linenums">if score := 61; score &gt; 80 {<br />
	fmt.Println("优秀")<br />
} else if score &gt; 60 {<br />
	fmt.Println("及格")<br />
} else {<br />
	fmt.Println("不及格")<br />
}
</pre>
</div>
<p>　　注意：花括号不可省，切不可另起一行。如果要声明变量，可以在if后面声明，并用分号分隔，分号后面跟条件。</p>
<p>　　最最重要的是：if后面的条件必须是bool类型的值或者结果为bool类型的表达式，不可以是整型或者其他类型。</p>
<h2>switch选择结构</h2>
<div>
<pre class="prettyprint linenums">var length int = 3<br />
switch length {<br />
case len("abc"): //可以是表达式<br />
	fmt.Println(3)<br />
case 4:<br />
	fmt.Println(4)<br />
default:<br />
	fmt.Println(5)<br />
}<br />
//输出<br />
//3</pre>
</div>
<p>　　Go语言中的switch case结构中，每一个case条件分支末尾不用加break；</p>
<p>　　case可以后面的条件可以使变量，也可以是常量，但是有一点：case后面的类型，要和switch后面的类型相同。</p>
<h3>　　fallthrough关键字</h3>
<div>
<pre class="prettyprint linenums">var score int = 12<br />
switch score {<br />
case 6:<br />
	fallthrough<br />
case 12:<br />
	fmt.Println(12)<br />
	fallthrough<br />
case 24:<br />
	fmt.Println(24)<br />
default:<br />
	fmt.Println(36)<br />
}<br />//输出<br />//12<br />//24</pre>
</div>
<p>　　如果某个case里面有fallthrough，那么，这个case的紧接着的下一个case条件会默认满足，直接执行写一个case中的语句，并不会判断下一个case的条件是否满足。</p>
<h3>　　case可以这样写</h3>
<div>
<pre class="prettyprint linenums">var score int = 12<br />
switch score {<br />
case 6, 12:<br />
	fmt.Println(6, "或者", 12)<br />
default:<br />
	fmt.Println(36)<br />
}
</pre>
</div>
<p>　　</p>
<h3>　　省略switch后面的表达式，此时相当于if else</h3>
<div>
<pre class="prettyprint linenums">var score int = 90<br />
switch {<br />
case score &gt; 80:<br />
	fmt.Println("优秀")<br />
	fallthrough<br />
case score &gt; 60:<br />
	fmt.Println("及格")<br />
default:<br />
	fmt.Println("不及格")<br />
}<br />
//输出<br />
//优秀<br />
//及格
</pre>
</div>
<p>　　</p>
<h2>for循环</h2>
<p>　　Go语言中没有while循环和do..while循环，只有一个for循环，但是for循环有三种形式，可以替代while循环和do while循环。</p>
<div>
<pre class="prettyprint linenums">for i:=0;i&lt;10;i++{<br />
	fmt.Println(i)<br />
}<br />
for {<br />
	fmt.Println("这是死循环，相当于while(1)")<br />
}<br />
for i,v := range m{<br />
	fmt.Println("同样是死循环")<br />
}
</pre>
</div>
<p>　　上面三种用法分别对应其他语言中的for循环，while()循环，do..while循环。</p>
<p>　　在循环中可以使用break和continue来控制循环。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8eo0mkq.html">后台启动weblogic成功后，在web浏览器上无法访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw4kxk8.html">inoic start projectname sidemenu报错 - Error&colon; Cannot find module &amp;&num;39&semi;lodash&period;&lowbar;baseslice&amp;&num;39&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zn3rd8.html">Java成员初始化顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2r0zx9.html">【Spring】Spring系列5之Spring支持事务处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j006vgq.html">C&num;压缩加密和vb压缩加密</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmx7rz9.html">Missra开源前端框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1egxx8.html">解决IE6&comma;IE7不能隐藏绝对定位溢出的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1vnl2q.html">ramfs&sol;tmpfs&colon; Linux RAM filesystems</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kp2l29.html">js正则表达式验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m53vj8.html">shell的date日期循环方法：日期格式转时间戳计算，再将时间戳转回日期格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eylvnm9.html">C Primer Plus 第9章 函数 编程练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1zdrw9.html">zip 格式解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjpxr49.html">Python语法基础-函数，类以及调试处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjkx169.html">redux &amp;amp&semi; react-redux</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e43pkx9.html">J2EE十三个技术规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o12nmpq.html">Java高并发情况下的锁机制优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j15lk09.html">&lbrack;UE4&rsqb;捡枪</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4ve21q.html">分析 HTML 代码并提取数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjrx3p8.html">Netty源码分析第2章&lpar;NioEventLoop&rpar;----&amp;gt&semi;第7节&colon; 处理IO事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v2ov2q.html">thread&lowbar;indent</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gjxlze9.html">js中typeof与instanceof用法小记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllxzk0q.html">go标准库的学习-net&sol;http</a>
			</li>
						<li><a href="https://www.batexi.com/a/960gjnn9.html">如何在Qt Creator中导入图标资源</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll7jnxq.html">ubuntu RPLIDAR A2的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rlrlm9.html">day81</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyxym2q.html">php中按值传递和按引用传递的一个问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwep5y8.html">CF11D A Simple Task 状压DP</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2zj30q.html">CF1060E Sergey and Subways 假的点分治</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdxlxe9.html">ListView 控件和 INotifyPropertyChanged 接口</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyx2kdq.html">Can not find the tag library descriptor for &amp;quot&semi;http&colon;&sol;&sol;java&period;sun&period;com&sol;jsp&sol;jstl&sol;core&amp;quot&semi;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
